#include <LiquidCrystal.h>


int red = 11;
int blue = 10;
int green = 9;
int signal = 12;
int trig = 2;
int echo = 3;
int motion = 0;



LiquidCrystal lcd(13, 7, 6, 5, 4, A1);
// these pins are listed in order from RS to DB7

//int register select = 13;
// int enable = 7;
// int DB4 = 6;
// int DB5 = 5;
// int DB6 = 4;
// int DB7 = A1;
void setup()
{
  // setting all the components to OUTPUT and INPUT
  Serial.begin(9600);
  pinMode(red, OUTPUT);
  pinMode(blue,OUTPUT);
  pinMode(green, OUTPUT);
  pinMode(signal, INPUT);
  pinMode(trig, OUTPUT);
  pinMode(echo, INPUT);
  lcd.begin(16, 2);
  
 }

void setColour(int r, int b, int g)
{
  // this is so that we can set the colours easily with the numbers 0-255 which means 0V to 5V
  analogWrite(red, r);
  analogWrite(blue, b);
  analogWrite(green, g);
}

void loop()
{
  long duration, distance;// setting so the distance sensor will function
  
  digitalWrite(trig, LOW);
  delayMicroseconds(2);// wait 2 microseconds 
  digitalWrite(trig, HIGH);
  delayMicroseconds(10); // wait 10 microseconds
  digitalWrite(trig, LOW);
  
  duration = pulseIn(echo, HIGH);
  // all of this code helps to command the distance sensor 
  
  distance = (duration/74)/2;// formula for calculating the distance
  Serial.println(duration);// this is to see on the serial  monitor what is happening to duration
  lcd.clear();
  lcd.setCursor(0,0);// this sets the text on spefic lines on the LCD so if you want the message below spaced out ect..
  lcd.print(distance);// this is so whatever the distance is on the sensor, it gets printed on the LCD
  lcd.setCursor(5,0);
  lcd.print("inches");// we will be able to see this on the display
  
 if (distance>= 0 && distance <10)
 {
  Serial.println("this is a test");
  setColour(0,255,0);// blue
 }
 else  if (distance>= 10 && distance <20)
 { 
   setColour(0,0,255);//green
 }
 else  if (distance>= 20 && distance <30)
 {
   setColour(155,238,15);//purple
 }
 else  if (distance>= 30  && distance <40)
 {
   setColour(255,188,0);//pink
 }
 else  if (distance>= 40 && distance <50)
 {
  setColour(0,255,247);//turquoise
 }
 else  if (distance>= 50 && distance <60)
 {
  setColour(205,0,255);//lime yellow
 }
 else  if (distance>= 60 && distance <70)
 {
  setColour(255,0,230);//yellow
 }
 else  if (distance>= 70 && distance <80)
 {
  setColour(255,0,128);//orange
 }
 else  if (distance>= 80 && distance <90)
 {
  setColour(81,17,60);//brown
 }
 else  if (distance>= 90 && distance <100)
 {
  setColour(17,68,81);//darkesh blue green
 }

// all of the if else statements help to define what the RGBs color is depending on distance in inches.
  
  motion = digitalRead(signal);// this reads the input value
  Serial.println(motion);// this is to check if this works on serial monitor
  if(motion == 1)
  {
    setColour(255,0,0);// setting the colour to red
    lcd.setCursor(0,1);
    lcd.print("motion detected");
  
  }
  else
  {
  lcd.setCursor(0,1);
  //lcd.print("000000000000000");
  }
  delay(100);
 // this part is stating if motion is detect the light will turn red and the lcd will display motion detected 
 // and if there is no more motion the RGB will turn off or not be red anymore and will display 0000000000, just to show that there is nothing there.
 
}